summaryrefslogtreecommitdiff
path: root/scripts/runqemu
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/runqemu')
-rwxr-xr-xscripts/runqemu427
1 files changed, 339 insertions, 88 deletions
diff --git a/scripts/runqemu b/scripts/runqemu
index 7d5107f14..fc7363fdd 100755
--- a/scripts/runqemu
+++ b/scripts/runqemu
@@ -1,8 +1,8 @@
#!/bin/bash
-
-# Handle Poky <-> QEmu interface voodoo
#
-# Copyright (C) 2006-2007 OpenedHand Ltd.
+# Handle running OE images standalone with QEMU
+#
+# Copyright (C) 2006-2011 Linux Foundation
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
@@ -17,133 +17,384 @@
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-
-if [ "x$BUILDDIR" = "x" ]; then
- echo "You need to source poky-init-build-env before running this script"
+usage() {
+ MYNAME=`basename $0`
+ echo ""
+ echo "Usage: you can run this script with any valid combination"
+ echo "of the following options (in any order):"
+ echo " QEMUARCH - the qemu machine architecture to use"
+ echo " KERNEL - the kernel image file to use"
+ echo " ROOTFS - the rootfs image file or nfsroot directory to use"
+ echo " MACHINE=xyz - the machine name (optional, autodetected from KERNEL filename if unspecified)"
+ echo " Simplified QEMU command-line options can be passed with:"
+ echo " nographic - disables video console"
+ echo " serial - enables a serial console on /dev/ttyS0"
+ echo " kvm - enables KVM when running qemux86/qemux86-64 (VT-capable CPU required)"
+ echo " qemuparams=\"xyz\" - specify custom parameters to QEMU"
+ echo " bootparams=\"xyz\" - specify custom kernel parameters during boot"
+ echo ""
+ echo "Examples:"
+ echo " $MYNAME qemuarm"
+ echo " $MYNAME qemux86-64 core-image-sato ext3"
+ echo " $MYNAME path/to/bzImage-qemux86.bin path/to/nfsrootdir/ serial"
+ echo " $MYNAME qemux86 qemuparams=\"-m 256\""
+ echo " $MYNAME qemux86 bootparams=\"psplash=false\""
exit 1
+}
+
+if [ "x$1" = "x" ]; then
+ usage
fi
-INTERNAL_SCRIPT=`which poky-qemu-internal`
+error() {
+ echo "Error: "$*
+ usage
+}
+
+MACHINE=${MACHINE:=""}
+KERNEL=""
+FSTYPE=""
+ROOTFS=""
+LAZY_ROOTFS=""
+SCRIPT_QEMU_OPT=""
+SCRIPT_QEMU_EXTRA_OPT=""
+SCRIPT_KERNEL_OPT=""
-if [ "x$1" = "x" ]; then
- echo
- echo "Run as $0 MACHINE IMAGETYPE ZIMAGE IMAGEFILE"
- echo "where:"
- echo " MACHINE - the machine to emulate (qemuarm, qemux86)"
- echo " IMAGETYPE - the type of image to run (ext2, nfs) (default: ext2)"
- echo " ZIMAGE - the kernel to use (optional)"
- echo " IMAGEFILE - the image file/location to use (optional)"
- exit 1
-else
- MACHINE=$1
+# Determine whether the file is a kernel or QEMU image, and set the
+# appropriate variables
+process_filename() {
+ filename=$1
+
+ # Extract the filename extension
+ EXT=`echo $filename | awk -F . '{ print \$NF }'`
+ case /$EXT/ in
+ /bin/)
+ # A file ending in .bin is a kernel
+ [ -z "$KERNEL" ] && KERNEL=$filename || \
+ error "conflicting KERNEL args [$KERNEL] and [$filename]"
+ ;;
+ /ext[234]/|/jffs2/|/btrfs/)
+ # A file ending in a supportted fs type is a rootfs image
+ if [ -z "$FSTYPE" -o "$FSTYPE" = "$EXT" ]; then
+ FSTYPE=$EXT
+ ROOTFS=$filename
+ else
+ error "conflicting FSTYPE types [$FSTYPE] and [$EXT]"
+ fi
+ ;;
+ *)
+ error "unknown file arg [$filename]"
+ ;;
+ esac
+}
+
+# Parse command line args without requiring specific ordering. It's a
+# bit more complex, but offers a great user experience.
+KVM_ENABLED="no"
+while true; do
+ arg=${1}
+ case "$arg" in
+ "qemux86" | "qemux86-64" | "qemuarm" | "qemumips" | "qemuppc")
+ [ -z "$MACHINE" ] && MACHINE=$arg || \
+ error "conflicting MACHINE types [$MACHINE] and [$arg]"
+ ;;
+ "ext2" | "ext3" | "jffs2" | "nfs" | "btrfs")
+ [ -z "$FSTYPE" -o "$FSTYPE" = "$arg" ] && FSTYPE=$arg || \
+ error "conflicting FSTYPE types [$FSTYPE] and [$arg]"
+ ;;
+ *-image*)
+ [ -z "$ROOTFS" ] || \
+ error "conflicting ROOTFS args [$ROOTFS] and [$arg]"
+ if [ -f "$arg" ]; then
+ process_filename $arg
+ elif [ -d "$arg" ]; then
+ # Handle the case where the nfsroot dir has -image-
+ # in the pathname
+ echo "Assuming $arg is an nfs rootfs"
+ FSTYPE=nfs
+ ROOTFS=$arg
+ else
+ ROOTFS=$arg
+ LAZY_ROOTFS="true"
+ fi
+ ;;
+ "nographic")
+ SCRIPT_QEMU_OPT="$SCRIPT_QEMU_OPT -nographic"
+ SCRIPT_KERNEL_OPT="$SCRIPT_KERNEL_OPT console=ttyS0"
+ ;;
+ "serial")
+ SCRIPT_QEMU_OPT="$SCRIPT_QEMU_OPT -serial stdio"
+ SCRIPT_KERNEL_OPT="$SCRIPT_KERNEL_OPT console=ttyS0"
+ ;;
+ "qemuparams="*)
+ SCRIPT_QEMU_EXTRA_OPT="${arg##qemuparams=}"
+
+ # Warn user if they try to specify serial or kvm options
+ # to use simplified options instead
+ serial_option=`expr "$SCRIPT_QEMU_EXTRA_OPT" : '.*\(-serial\)'`
+ kvm_option=`expr "$SCRIPT_QEMU_EXTRA_OPT" : '.*\(-enable-kvm\)'`
+ [ ! -z "$serial_option" -o ! -z "$kvm_option" ] && \
+ error "Please use simplified serial or kvm options instead"
+ ;;
+ "bootparams="*)
+ SCRIPT_KERNEL_OPT="$SCRIPT_KERNEL_OPT ${arg##bootparams=}"
+ ;;
+ "audio")
+ if [ "x$MACHINE" = "xqemux86" -o "x$MACHINE" = "xqemux86-64" ]; then
+ echo "Enabling audio in qemu."
+ echo "Please install snd_intel8x0 or snd_ens1370 driver in linux guest."
+ QEMU_AUDIO_DRV="alsa"
+ SCRIPT_QEMU_OPT="$SCRIPT_QEMU_OPT -soundhw ac97,es1370"
+ fi
+ ;;
+ "kvm")
+ KVM_ENABLED="yes"
+ KVM_CAPABLE=`grep -q 'vmx\|smx' /proc/cpuinfo && echo 1`
+ ;;
+ "") break ;;
+ *)
+ # A directory name is an nfs rootfs
+ if [ -d "$arg" ]; then
+ echo "Assuming $arg is an nfs rootfs"
+ if [ -z "$FSTYPE" -o "$FSTYPE" = "nfs" ]; then
+ FSTYPE=nfs
+ else
+ error "conflicting FSTYPE types [$arg] and nfs"
+ fi
+
+ if [ -z "$ROOTFS" ]; then
+ ROOTFS=$arg
+ else
+ error "conflicting ROOTFS args [$ROOTFS] and [$arg]"
+ fi
+ elif [ -f "$arg" ]; then
+ process_filename $arg
+ else
+ error "unable to classify arg [$arg]"
+ fi
+ ;;
+ esac
shift
+done
+
+if [ ! -c /dev/net/tun ] ; then
+ echo "TUN control device /dev/net/tun is unavailable; you may need to enable TUN (e.g. sudo modprobe tun)"
+ exit 1
+elif [ ! -w /dev/net/tun ] ; then
+ echo "TUN control device /dev/net/tun is not writable, please fix (e.g. sudo chmod 666 /dev/net/tun)"
+ exit 1
fi
-if [ "x$1" != "x" ]; then
- TYPE=$1
- shift
-else
- TYPE="ext3"
- if [ "$MACHINE" = "akita" ]; then
- TYPE="jffs2"
+YOCTO_KVM_WIKI="https://wiki.yoctoproject.org/wiki/How_to_enable_KVM_for_Poky_qemu"
+# Detect KVM configuration
+if [ "x$KVM_ENABLED" = "xyes" ]; then
+ if [ -z "$KVM_CAPABLE" ]; then
+ echo "You are trying to enable KVM on a cpu without VT support."
+ echo "Remove kvm from the command-line, or refer"
+ echo "$YOCTO_KVM_WIKI";
+ exit 1;
+ fi
+ if [ "x$MACHINE" != "xqemux86" -a "x$MACHINE" != "xqemux86-64" ]; then
+ echo "KVM only support x86 & x86-64. Remove kvm from the command-line";
+ exit 1;
fi
- if [ "$MACHINE" = "nokia800" ]; then
- TYPE="jffs2"
+ if [ ! -e /dev/kvm ]; then
+ echo "Missing KVM device. Have you inserted kvm modules?"
+ echo "For further help see"
+ echo "$YOCTO_KVM_WIKI";
+ exit 1;
fi
- if [ "$MACHINE" = "spitz" ]; then
- TYPE="ext3"
+ if 9<>/dev/kvm ; then
+ SCRIPT_QEMU_OPT="$SCRIPT_QEMU_OPT -enable-kvm"
+ else
+ echo "You have no rights on /dev/kvm."
+ echo "Please change the ownership of this file as described at"
+ echo "$YOCTO_KVM_WIKI";
+ exit 1;
fi
fi
-if [ "x$1" != "x" ]; then
- ZIMAGE=$1
- shift
+# Report errors for missing combinations of options
+if [ -z "$MACHINE" -a -z "$KERNEL" ]; then
+ error "you must specify at least a MACHINE or KERNEL argument"
fi
-
-if [ "x$1" != "x" ]; then
- HDIMAGE=$1
- shift
+if [ "$FSTYPE" = "nfs" -a -z "$ROOTFS" ]; then
+ error "NFS booting without an explicit ROOTFS path is not yet supported"
fi
-if [ "$MACHINE" = "qemuarm" -o "$MACHINE" = "spitz" -o "$MACHINE" = "borzoi" -o "$MACHINE" = "akita" -o "$MACHINE" = "nokia800" ]; then
- if [ "x$ZIMAGE" = "x" ]; then
- ZIMAGE=$BUILDDIR/tmp/deploy/images/zImage-$MACHINE.bin
+if [ -z "$MACHINE" ]; then
+ MACHINE=`basename $KERNEL | sed 's/.*-\(qemux86-64\|qemux86\|qemuarm\|qemumips\|qemuppc\).*/\1/'`
+ if [ -z "$MACHINE" ]; then
+ error "Unable to set MACHINE from kernel filename [$KERNEL]"
fi
- CROSSPATH=$BUILDDIR/tmp/cross/arm-poky-linux-gnueabi/bin
+ echo "Set MACHINE to [$MACHINE] based on kernel [$KERNEL]"
fi
+machine2=`echo $MACHINE | tr 'a-z' 'A-Z' | sed 's/-/_/'`
+# MACHINE is now set for all cases
+
+# Defaults used when these vars need to be inferred
+QEMUX86_DEFAULT_KERNEL=bzImage-qemux86.bin
+QEMUX86_DEFAULT_FSTYPE=ext3
+
+QEMUX86_64_DEFAULT_KERNEL=bzImage-qemux86-64.bin
+QEMUX86_64_DEFAULT_FSTYPE=ext3
+
+QEMUARM_DEFAULT_KERNEL=zImage-qemuarm.bin
+QEMUARM_DEFAULT_FSTYPE=ext3
+
+QEMUMIPS_DEFAULT_KERNEL=vmlinux-qemumips.bin
+QEMUMIPS_DEFAULT_FSTYPE=ext3
+
+QEMUPPC_DEFAULT_KERNEL=vmlinux-qemuppc.bin
+QEMUPPC_DEFAULT_FSTYPE=ext3
+
+AKITA_DEFAULT_KERNEL=zImage-akita.bin
+AKITA_DEFAULT_FSTYPE=jffs2
+
+SPITZ_DEFAULT_KERNEL=zImage-spitz.bin
+SPITZ_DEFAULT_FSTYPE=ext3
-function findimage {
+setup_tmpdir() {
+ if [ -z "$OE_TMPDIR" ]; then
+ # Try to get OE_TMPDIR from bitbake
+ type -P bitbake &>/dev/null || {
+ echo "In order for this script to dynamically infer paths";
+ echo "to kernels or filesystem images, you either need";
+ echo "bitbake in your PATH or to source oe-init-build-env";
+ echo "before running this script" >&2;
+ exit 1; }
+
+ # We have bitbake in PATH, get OE_TMPDIR from bitbake
+ OE_TMPDIR=`bitbake -e | grep ^TMPDIR=\" | cut -d '=' -f2 | cut -d '"' -f2`
+ if [ -z "$OE_TMPDIR" ]; then
+ echo "Error: this script needs to be run from your build directory,"
+ echo "or you need to explicitly set OE_TMPDIR in your environment"
+ exit 1
+ fi
+ fi
+}
+
+setup_sysroot() {
+ # Toolchain installs set up $OECORE_NATIVE_SYSROOT in their
+ # environment script. If that variable isn't set, we're
+ # either in an in-tree build scenario or the environment
+ # script wasn't source'd.
+ if [ -z "$OECORE_NATIVE_SYSROOT" ]; then
+ setup_tmpdir
+ BUILD_ARCH=`uname -m`
+ BUILD_OS=`uname | tr '[A-Z]' '[a-z]'`
+ BUILD_SYS="$BUILD_ARCH-$BUILD_OS"
+
+ OECORE_NATIVE_SYSROOT=$OE_TMPDIR/sysroots/$BUILD_SYS
+ fi
+}
+
+# Locate a rootfs image to boot which matches our expected
+# machine and fstype.
+findimage() {
where=$1
machine=$2
extension=$3
- names=$4
- for name in $names;
- do
- fullname=$where/$name-$machine.$extension
- if [ -e "$fullname" ]; then
- HDIMAGE=$fullname
+
+ # Sort rootfs candidates by modification time - the most
+ # recently created one is the one we most likely want to boot.
+ filenames=`ls -t $where/*-image*$machine.$extension 2>/dev/null | xargs`
+ for name in $filenames; do
+ case $name in
+ *core-image-sato* | \
+ *core-image-lsb* | \
+ *core-image-basic* | \
+ *core-image-minimal* )
+ ROOTFS=$name
return
- fi
- done
- echo "Couldn't find image in $where. Attempted image names were:"
- for name in $names;
- do
- echo $name-$machine.$extension
+ ;;
+ esac
done
+
+ echo "Couldn't find a $machine rootfs image in $where."
exit 1
}
-if [ "$MACHINE" = "qemuarm" ]; then
- if [ "$TYPE" = "ext3" ]; then
- if [ "x$HDIMAGE" = "x" ]; then
- T=$BUILDDIR/tmp/deploy/images
- findimage $T qemuarm ext3 "poky-image-sdk poky-image-sato poky-image-minimal"
- fi
+if [ -e "$ROOTFS" -a -z "$FSTYPE" ]; then
+ # Extract the filename extension
+ EXT=`echo $ROOTFS | awk -F . '{ print \$NF }'`
+ if [ "x$EXT" = "xext2" -o "x$EXT" = "xext3" -o \
+ "x$EXT" = "xjffs2" -o "x$EXT" = "xbtrfs" ]; then
+ FSTYPE=$EXT
+ else
+ echo "Note: Unable to determine filesystem extension for $ROOTFS"
+ echo "We will use the default FSTYPE for $MACHINE"
+ # ...which is done further below...
fi
fi
-if [ "$MACHINE" = "spitz" ]; then
- if [ "$TYPE" = "ext3" ]; then
- if [ "x$HDIMAGE" = "x" ]; then
- HDIMAGE=$BUILDDIR/tmp/deploy/images/poky-image-sato-spitz.ext3
- fi
+if [ -z "$KERNEL" ]; then
+ setup_tmpdir
+ eval kernel_file=\$${machine2}_DEFAULT_KERNEL
+ KERNEL=$OE_TMPDIR/deploy/images/$kernel_file
+
+ if [ -z "$KERNEL" ]; then
+ error "Unable to determine default kernel for MACHINE [$MACHINE]"
fi
fi
+# KERNEL is now set for all cases
-if [ "$MACHINE" = "akita" ]; then
- if [ "$TYPE" = "jffs2" ]; then
- if [ "x$HDIMAGE" = "x" ]; then
- HDIMAGE=$BUILDDIR/tmp/deploy/images/poky-image-sato-akita.jffs2
- fi
+if [ -z "$FSTYPE" ]; then
+ eval FSTYPE=\$${machine2}_DEFAULT_FSTYPE
+
+ if [ -z "$FSTYPE" ]; then
+ error "Unable to determine default fstype for MACHINE [$MACHINE]"
fi
fi
-if [ "$MACHINE" = "nokia800" ]; then
- if [ "$TYPE" = "jffs2" ]; then
- if [ "x$HDIMAGE" = "x" ]; then
- HDIMAGE=$BUILDDIR/tmp/deploy/images/poky-image-sato-nokia800.jffs2
- fi
- fi
+# FSTYPE is now set for all cases
+
+# Handle cases where a ROOTFS type is given instead of a filename, e.g.
+# core-image-sato
+if [ "$LAZY_ROOTFS" = "true" ]; then
+ setup_tmpdir
+ echo "Assuming $ROOTFS really means $OE_TMPDIR/deploy/images/$ROOTFS-$MACHINE.$FSTYPE"
+ ROOTFS=$OE_TMPDIR/deploy/images/$ROOTFS-$MACHINE.$FSTYPE
fi
+if [ -z "$ROOTFS" ]; then
+ setup_tmpdir
+ T=$OE_TMPDIR/deploy/images
+ eval rootfs_list=\$${machine2}_DEFAULT_ROOTFS
+ findimage $T $MACHINE $FSTYPE
-if [ "$MACHINE" = "qemux86" ]; then
- if [ "x$ZIMAGE" = "x" ]; then
- ZIMAGE=$BUILDDIR/tmp/deploy/images/bzImage-$MACHINE.bin
+ if [ -z "$ROOTFS" ]; then
+ error "Unable to determine default rootfs for MACHINE [$MACHINE]"
fi
- if [ "$TYPE" = "ext3" ]; then
- if [ "x$HDIMAGE" = "x" ]; then
- T=$BUILDDIR/tmp/deploy/images
- findimage $T qemux86 ext3 "poky-image-sdk poky-image-sato poky-image-minimal moblin-image-netbook"
- fi
- fi
- CROSSPATH=$BUILDDIR/tmp/cross/i586-poky-linux/bin
fi
+# ROOTFS is now set for all cases
+
+echo ""
+echo "Continuing with the following parameters:"
+echo "KERNEL: [$KERNEL]"
+echo "ROOTFS: [$ROOTFS]"
+echo "FSTYPE: [$FSTYPE]"
+
+setup_sysroot
+# OECORE_NATIVE_SYSROOT is now set for all cases
-if [ ! -e $CROSSPATH/cc ]; then
- ln -s $CROSSPATH/gcc $CROSSPATH/cc
+# We can't run without a libGL.so
+libgl='no'
+
+[ -e /usr/lib/libGL.so -a -e /usr/lib/libGLU.so ] && libgl='yes'
+[ -e /usr/lib64/libGL.so -a -e /usr/lib64/libGLU.so ] && libgl='yes'
+[ -e /usr/lib/*-linux-gnu/libGL.so -a -e /usr/lib/*-linux-gnu/libGLU.so ] && libgl='yes'
+
+if [ "$libgl" != 'yes' ]; then
+ echo "You need libGL.so and libGLU.so to exist in your library path to run the QEMU emulator.
+ Ubuntu package names are: libgl1-mesa-dev and libglu1-mesa-dev.
+ Fedora package names are: mesa-libGL mesa-libGLU."
+ exit 1;
fi
-CROSSPATH=$BUILDDIR/tmp/staging/$BUILD_SYS/usr/bin:$CROSSPATH:$BUILDDIR/tmp/cross/bin
+INTERNAL_SCRIPT="$0-internal"
+if [ ! -f "$INTERNAL_SCRIPT" -o ! -r "$INTERNAL_SCRIPT" ]; then
+INTERNAL_SCRIPT=`which runqemu-internal`
+fi
. $INTERNAL_SCRIPT